unit hiStreamCopy;

interface

uses
  Kol, Share, Debug, Windows;

type
  THIStreamCopy = class(TDebug)
    private
    public
      _prop_Count: Integer;
      _prop_BufferSize: Integer;

      _event_onCopy: THI_Event;
      _data_Count: THI_Event;
      _data_Source: THI_Event;
      _data_Dest: THI_Event;

      procedure _work_doCopy(var _Data: TData; Index: Word);
  end;
  
  function StreamToStream(Dst, Src: PStream; Count, BufSize: DWORD): DWORD;
  
  
implementation


function StreamToStream(Dst, Src: PStream; Count, BufSize: DWORD): DWORD;
var
  Buf: Pointer;
  R, W: DWORD;
begin
  Result := 0;
  if Count = 0 then Exit;
  
  if (BufSize > Count) or (BufSize = 0) then BufSize := Count;
  
  //  Memory-     Kol.Stream2Stream()
  if Src.Memory <> nil then
  begin
    if Src.Position + Count > Src.Size then
      Count := Src.Size - Src.Position;
    Result := Dst.Write(Pointer(DWORD(Src.Memory) + Src.Position)^,
                        Count);
    Src.Seek(Result, spCurrent);
  end
  else
    if Dst.Memory <> nil then
    begin
      if Dst.Position + Count > Dst.Size then
         Dst.Size := Dst.Position + Count;
      Result := Src.Read(Pointer(DWORD(Dst.Memory) + Dst.Position)^,
                          Count);
      Dst.Seek(Result, spCurrent);
    end
    else  //    ...
    begin
      GetMem(Buf, BufSize);
      try
        while Count >= BufSize do //    
        begin
          R := Src.Read(Buf^, BufSize);
          W := Dst.Write(Buf^, R);
          Inc(Result, W);
          if (R < BufSize) //   
             or (W < R)    //       
          then 
          begin
            FreeMem(Buf);
            Exit;
          end; 
          Dec(Count, BufSize);
        end;
        
        if Count > 0 then //  
        begin
          Inc(Result, Dst.Write(Buf^, Src.Read(Buf^, Count)));
        end;
      finally
        FreeMem(Buf);
      end;
    end;
end;


procedure THIStreamCopy._work_doCopy;
var
  st1, st2: PStream;
  Count: Cardinal;
begin
  st1 := ReadStream(_Data, _data_Dest, nil);
  st2 := ReadStream(_Data, _data_Source, nil);
  Count := ReadInteger(_Data, _data_Count, _prop_Count);
  if (st1 <> nil) and (st2 <> nil) then 
  begin
    if _prop_BufferSize > 0 then
      _hi_CreateEvent(_Data, @_event_onCopy, Integer(StreamToStream(st1, st2, Count, _prop_BufferSize)))
    else
      _hi_CreateEvent(_Data, @_event_onCopy, Integer(Stream2Stream(st1, st2, Count)));
  end;
end;

end.
